<?php
require_once('parallelCurl.php');
set_time_limit(300);

function monsterNameToFileName($monsterName)
{
	return str_replace(' ', '_', str_replace('.', '_', strtolower($monsterName)));
}

function onImageDownload($content, $url, $ch, $monster)
{
	global $zip;
	
	$httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	if ($httpcode !== 200)
	{
		//print "Fetch error $httpcode for '$url'\n";
		return;
	}
	if (strlen($content) > 200) // minimum image size, longer then typical server error messages
	{
		if ($monster->img == 'item')
		{
			// change gif to png
			ob_start();
			imagepng(imagecreatefromstring($content));
			$content = ob_get_clean();
		}
		$zip->addFromString(monsterNameToFileName($monster->name) . '.png', $content);
	}
}

$monstersList = json_decode($_POST['data']);
if (!$monstersList || !is_array($monstersList) || count($monstersList) == 0)
{
	exit('Empty monsters list. Nothing to download.');
}
if (count($monstersList) > 2000)
{
	exit('Maximum number of files to download is 2000.');
}

$zipFile = tempnam('tmp', 'zip');

if (!$zipFile)
{
	exit('Failed to create ZIP file. Try again later.');
}
$zip = new ZipArchive();

$curl_options  = array(
	CURLOPT_SSL_VERIFYPEER => FALSE,
	CURLOPT_SSL_VERIFYHOST => FALSE,
	CURLOPT_USERAGENT,
	'Parallel Curl test script'
);
$parallel_curl = new ParallelCurl(10, $curl_options);

if ($zip->open($zipFile, ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE) === true)
{
	foreach ($monstersList as $monster)
	{
		if ($monster->img == 'item')
		{
			$imgPath = 'http://item-images.ots.me/1076/' . ((int) $monster->id) . '.gif';
		}
		else // creature
		{
			$imgPath = 'http://outfit-images.ots.me/outfit.php?id=' . ((int) $monster->id) . '&head=' . ((int) $monster->head) . '&body=' . ((int) $monster->body) . '&legs=' . ((int) $monster->legs) . '&feet=' . ((int) $monster->feet) . '&addons=' . ((int) $monster->addons);
		}
		$parallel_curl->startRequest($imgPath, 'onImageDownload', $monster);
	}
	$parallel_curl->finishAllRequests();
	
	$zip->close();
	
	header('Content-Type: application/zip');
	header('Content-Length: ' . filesize($zipFile));
	header('Content-Disposition: attachment; filename="monsters_images.zip"');
	readfile($zipFile);
	@unlink($imgFile);
	@unlink($zipFile);
}
else
{
	echo 'Failed to create or open temporary zip file.';
	@unlink($imgFile);
	@unlink($zipFile);
	exit;
}